#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include "defines.h"
#include "ir.h"

//ISR(INT2_vect) {;}
// Anschluss IR-Empfnger als ir_pin
// Anschluss IR-Empfnger als ir_pin
//kurz=F_CPU/1.000.000*889=3277,2096
// Lnge IR-Signale messen und in tmp[] abspeichern
//tmp[0]=1;

	u16 ir_signal(void){
		u8 ir_adr=0,ir_cmd=0,ir_div;
		u16 f_ir;
		u8 found=0;
		u8 oldBit;
		u16 rc5code,i;//50
		oldBit=1;
		u8 zl=0;
		u8 endwhile=1,n=1;
		u8         j;
		u16 wertx,colx;
		u16 tmp[110];
		u16 check_mod;
		ir_cmd=0;

	//signal messen

	while(endwhile){
			i=0;
			while(ir_pin && i<60001)i++;
			tmp[n]=i;//Speichert Anzahl der Ticks bis Flankenwechsel
			if(i==0)endwhile=0;
			i=0;
			while(!ir_pin && i<60001)i++;
			tmp[n+1]=i;
			if(i==0)endwhile=0;
			if(n<48)n=n+2;
	}
//	ir_cmd=(tmp[1])/(tmp[2]/10);
	ir_div=(tmp[1])/(tmp[2]/10);
	
	
	
	//rc5 -code
	if(ir_div>7 && ir_div<13)//rc5
	{
	f_ir=tmp[1]/10;
		tmp[0]=1;
		//IR-Signale aus tmp[] in Bitfolge rc5code umrechnen
		n=0;
			while(zl<14){
			rc5code=(rc5code<<1)+oldBit;zl++;//kurze Zeitspanne => Bit=oldBit, kein Wechsel
			if ((tmp[n+1]/f_ir)>15){tbi(oldBit,0);n=n-1;}//lange Spanne=>Bit!=oldBit,Wechsel
			n=n+2;}

			//ir_adr, ir_cmd
			ir_adr=(rc5code&0b0000011111000000)>>6;
			ir_adr|=64;

			ir_cmd=(rc5code&0b0000000000111111);
			if ((rc5code&0b0001000000000000)==0)ir_cmd=ir_cmd+0b0000000001000000;//c6-bit auswerten
		found=1;
	}

//================================================

	//NEC -code
	 if(ir_div>17 && ir_div<25){//nec 95
		f_ir=tmp[2]/46;
			ir_adr=0;ir_cmd=0;
			  for(i=32;i>17;i=i-2) {
				ir_adr=(ir_adr<<1);
				if (tmp[i]/f_ir>11)ir_adr++;}

			  for(i=48;i>33;i=i-2) {
				ir_cmd=(ir_cmd<<1);
				if (tmp[i]/f_ir>11)ir_cmd++;
			  }
				found=1;
		}
		//================================================
	return (ir_cmd |ir_adr<<8);
}






#if 0
int main(void)
{
	ir_signal();
    while(1)
    {
    }
}
#endif
