#ifndef _ds1820_v3_h
#define _ds1820_v3_h

//================= ds18b20 =============================
//    ____
// ___________
//_____________
// 1   2   3
//GND DAT VCC
//=======================================================
//pinout 

#define ds1820_verbose 0
#define ds1820_port D
#define ds1820_pin  7
#define ds1820_anz_sensor 5
#define eep_ds1820_adr  30
#define lcd_zeilen 4


//Tastaturabfrage für Speicherung neuer Sensoren
#define ds1820_tast_port		tast0_port
#define ds1820_tast_pin 		tast0_pin
#define tastds1820				!(pinVAL(tast0_port,tast0_pin))


void  ds1820_init(void);
void  ds1820_start_meas( void );
void  ds1820_read_meas( void );
void  sensors_show(void);
void  eep_show(u8 sel);
void  eeprom_in_array_einlesen(void);


	
extern int16_t 		ds1820_val[ds1820_anz_sensor];
extern int16_t 		ds1820_tmp[ds1820_anz_sensor];
extern int16_t 		ds1820_store[ds1820_anz_sensor];
extern uint16_t    	ds1820_id [ds1820_anz_sensor];
extern uint16_t    	ds1820_eep[ds1820_anz_sensor];
extern u8 sel_sensor, cur_alt, sel_eep;


#endif
